# useTrixtaReaction

{% code overflow="wrap" %}

```tsx
import { useTrixtaReaction } from '@trixtateam/trixta-js-core';
const { 
hasRoleAccess,
isInProgress,
latestResponse,
loading,
latestInstance,
instances,
initialData,
hasResponse,
submitTrixtaReaction,
clearReactionResponses,
} = useTrixtaReaction<TInitialData,TSuccessType,TErrorType>({ roleName:"",
  reactionName:"",
  requestForEffect:false,
  loadingStatusRef:"",
  debugMode: false,
  setTimeoutEventAsErrorEvent: false,
  clearResponsesOnCallback: false,
  onSuccess:(success)=>{},
  onError:(errror)=>{}
   });
```

{% endcode %}

### Options

* `roleName : string`
  * **Required**
  * Trixta role name

* `reactionName : string`

  * **Required**
  * Trixta reaction name

* `requestForEffect: boolean`

  * Optional
  * Defaults to false.
  * If set to `true`, this Trixta reaction is not waiting for a response and the only expect to use the initialData

* `loadingStatusRef: string`

  * Optional
  * Optional value to change the default isInProgress behaviour for when submitting reactions. If you plan to use the same reaction name for the same role, on the same screen, this is when you would make use of this \* property

* `debugMode: boolean`

  * Optional
  * Defaults to false.
  * If set to `true`, enables Trixta console debugging

* `setTimeoutEventAsErrorEvent: boolean`
  * Optional
  * Defaults to false.
  * If set to `true`, will set the `timeoutEvent` to be the same as the `errorEvent`<br>

* `clearResponsesOnCallback: boolean`

  * Optional
  * Defaults to false.
  * If set to `true`, will clear all responses when `onSuccess` or `onError` callbacks are called returning a value true

* `onSuccess : (success: TSuccessType) => void|boolean`

  * Optional
  * This function will fire any time a successful response is received from Trixta.
  * If you return `true` and clearResponsesOnCallback is `true`, all responses will be cleared.

* `onError : (error: TErrorType) => void|boolean`
  * Optional
  * This function will fire any time an error response is received from Trixta.
  * If you return `true` and clearResponsesOnCallback is `true`, all responses will be cleared.

### Returns

* `hasRoleAccess : boolean`

  * Will be `true` if the `roleName` has access for this user.

* `isInProgress : boolean`
  * Will be `true` if there is no response yet after calling `submitTrixtaReactionResponse` or `submitTrixtaReaction`.
  * Will be `false` if there is a response after calling `submitTrixtaReactionResponse` or `submitTrixtaReaction`<br>

* `hasResponse : boolean`

  * Will be `true` if there is at least one Trixta Instance response.

* `loading : boolean`

  * Will be `true` if the reaction is waiting to be loaded or receive a reaction.

* `latestResponse :` [`TrixtaReactionInstanceResponse`](/trixta-js-core/reference/types/reaction-related-types.md)

  * First or most recent Trixta instance response

* `initialData : TInitialData on` [`TrixtaReactionInstance`](/trixta-js-core/reference/types/reaction-related-types.md)

  * Initial data returned from Trixta reaction instance

* `latestInstance :` [`TrixtaReactionInstance`](/trixta-js-core/reference/types/reaction-related-types.md)

  * First or most recent Trixta instance

* `submitTrixtaReaction : (parameters:` [`SubmitTrixtaFunctionParameters`](/trixta-js-core/reference/methods/reactions/submittrixtareactionresponse.md)`) => void`

  * This function will submit a response for the given `roleName` and `reactionName`

  &#x20;

* `clearReactionResponses : () => void`
  * This function will clear and reset responses for the given `roleName` and `reactionName`.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://trixtateam.gitbook.io/trixta-js-core/reference/hooks/reactions/usetrixtareaction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
